package reversi.ai;
import java.util.List;

import reversi.model.Move;
import reversi.model.Player;
import reversi.model.ReversiBoard;


public class RandomAI extends ReversiAI {
	public RandomAI(Player p){
		super(p);
	}
	
	@Override
	public String toString(){
		return super.toString() + "/ Random AI";
	}

	@Override
	public MoveAndScore decideMove(ReversiBoard board) {
		List<Move> moves = board.getPossibleMoves(board.getCurrentTurn());
		Move m =  moves.isEmpty() ? null : moves.get((int) (Math.random() * moves.size()));
		return new MoveAndScore(m, 0);
	}
}
