package reversi.ai;

import reversi.model.Move;
import reversi.model.Player;
import reversi.model.ReversiBoard;

/** AI ̋ʕi̓I AI  ReversiAI pčj **/
public abstract class ReversiAI {
	private Player p;

	public ReversiAI(Player p){
		this.p = p;
	}

	public Player getTurn(){
		return p;
	}
	
	@Override
	public String toString(){
		return p.toString();
	}
	
	protected boolean isMyTurn(ReversiBoard board){
		return board.getCurrentTurn() == getTurn();
	}

	protected ReversiBoard createChild(ReversiBoard board, Move m){
		ReversiBoard child = new ReversiBoard(board);
		child.move(m);
		return child;
	}
	
	public abstract MoveAndScore decideMove(ReversiBoard board);
}
