package reversi.model;
import java.util.ArrayList;
import java.util.List;

/** ReversiBoard ɏԕύXƂɒʒm@\tNX **/
public class ReversiModel extends ReversiBoard {
	private List<ReversiModelListener> listeners;

	public ReversiModel(){
		super();
		listeners = new ArrayList<ReversiModelListener>();
	}
	
	public void addReversiModelListener(ReversiModelListener l){
		listeners.add(l);
	}
	
	private void notifyListeners(){
		for(ReversiModelListener l : listeners){
			l.changed(this);
		}
	}

	@Override
	public void initBoard() {
		super.initBoard();
		if(listeners != null) notifyListeners();
	}

	@Override
	public boolean move(int row, int column) {
		if(super.move(row, column)){
			notifyListeners();
			return true;
		}
		return false;
	}

	@Override
	public boolean pass() {
		if(super.pass()){
			notifyListeners();
			return true;
		}
		return false;
	}
}
